
/*Creation de Ecgen*/

DROP TABLE IF EXISTS ecgen;

CREATE TABLE `ecgen` (
  `idec` int(11) NOT NULL AUTO_INCREMENT,
  `nomprenom` varchar(80) DEFAULT NULL,
  `sexe` varchar(1) DEFAULT NULL,
  `datenaiss` varchar(8) DEFAULT NULL,
  `lieunaiss` varchar(8) DEFAULT NULL,
  `datedeces` varchar(8) DEFAULT NULL,
  `lieudeces` varchar(5) DEFAULT NULL,
  `id` int(11) DEFAULT NULL,
  `actedeces` varchar(9) DEFAULT NULL,
  PRIMARY KEY (`idec`),
  KEY `id` (`id`),
  KEY `Tout` (`nomprenom`,`sexe`,`datenaiss`,`lieunaiss`,`datedeces`,`lieudeces`,`actedeces`)
) ENGINE=InnoDB AUTO_INCREMENT=192733 DEFAULT CHARSET=utf8;


####################################################################
#                     MARQUAGE DES ERREURS                         #
####################################################################

/* Reset ErCode */
Update Inseeall set Ercode=0 where ErCode<>0;

####################################################################
#   Ec11 Actedeces vide                                             #
####################################################################
update inseeall set Ercode=11 where actedeces="";

####################################################################
#   Ec10 Lieu naissance vide                                       #
####################################################################
Update Inseeall set Ercode=10 where lieunaiss="" or lieunaiss is null;

/*
####################################################################
#   Ec5 : Date Naissance = xxxx xx 00                              #
####################################################################
*/
Update Inseeall set ErCode=5 where Substring(datenaiss,7,2)="00";

/*
####################################################################
#   Ec4 : Date Naissance = xxxx 00 xx                              #
####################################################################
*/
Update Inseeall set ErCode=4 where Substring(datenaiss,5,2)="00";

/*
####################################################################
#   Ec8 : Date décès = xxxx xx 00                              #
####################################################################
*/
Update Inseeall set ErCode=8 where Substring(datedeces,7,2)="00";

/*
####################################################################
#   Ec7 : Date décès = xxxx 00 xx                              #
####################################################################
*/
Update Inseeall set ErCode=7 where Substring(datedeces,5,2)="00";

/*
####################################################################
#   Ec6 : Date décès = 00000000                                #
####################################################################
*/
Update Inseeall set ErCode=6 where datedeces="00000000";

/*
####################################################################
#   Ec1 : décès intervenu avant la naissance                       #
####################################################################
*/
Update Inseeall set ErCode=1 Where datenaiss>datedeces;

/*
####################################################################
#   Ec2 : Date Décès incomplète                                    #
####################################################################
*/
Update Inseeall Set ErCode=2 where length(trim(datedeces))<8;

####################################################################
#   Ec9 Lieu décès vide                                            #
####################################################################
Update Inseeall set Ercode=9 where lieudeces="" or lieudeces is null;

/*
####################################################################
#   Ec3 : Date Naissance = 00000000                                #
####################################################################
*/
Update Inseeall set ErCode=3 where datenaiss="00000000" or Length(datenaiss)<>8;

/*
#######################################################################
#  Ec104 - Double (nomprenom, sexe, datenaiss, lieunaiss, datedeces)  #
#######################################################################
*/

/* EXPLICATION (ne sera pas répétée pour tous les codes 100)

Nous avons une table intermédiaire, EcGen, nous allons y insérer toutes les fiches de la table InseeAll 
correspondant au critère de regroupement (soit une ligne par doublon parfait).

Ensuite à l'étape "ajoute du champ id dans EcGen", nous allons reprendre les mêmes critères de regroupement et procéder au 
positionnement du champ id sur ce même regroupement, soit UN id parmi la liste.

Ensuite nous allons, dans InseeAll, pour tous les ID qui ne SONT PAS celui repris dans EcGen, mettre le Ercode à jour, ce qui nous permet de 
ne retenir comme valide qu'une seule fiche et marquer les autres en doublon...

*/

/* Peuplement de Ecgen */
truncate table ecgen;

insert into ecgen
select NULL as idec, nomprenom, sexe, datenaiss, lieunaiss, datedeces, lieudeces,0,NULL from Inseeall
group BY
nomprenom, sexe, datenaiss, lieunaiss, datedeces
HAVING  
COUNT(*)>1;

/*Ajoute du champ Id dans Ecgen*/
update ecgen inner join Inseeall on
(
Inseeall.nomprenom=ecgen.nomprenom AND Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces 
)
set ecgen.id=Inseeall.id;

/*Positionnement du champ ErCode dans Inseeall pour toutes les fiches dont l'Id n'est pas celle de Ecgen*/
update ecgen inner join Inseeall on 
(
Inseeall.nomprenom=ecgen.nomprenom AND Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces
)
set Ercode=104
Where Inseeall.id<>Ecgen.id;

/*
#######################################################################
#   Ec103 - Double (sexe datenaiss, lieunaiss, datedeces, lieudeces)  #
#######################################################################
*/

/* Peuplement de Ecgen */
truncate table ecgen;

insert into ecgen
select NULL as idec, "", sexe, datenaiss, lieunaiss, datedeces, lieudeces,0,NULL from Inseeall
group BY
sexe, datenaiss, lieunaiss, datedeces, lieudeces
HAVING  
COUNT(*)>1;

/*Ajoute du champ Id dans Ecgen*/
update ecgen inner join Inseeall on
(
Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND Inseeall.lieudeces=ecgen.lieudeces
)
set ecgen.id=Inseeall.id;

/*Positionnement du champ ErCode dans Inseeall pour toutes les fiches dont l'Id n'est pas celle de Ecgen*/
update ecgen inner join Inseeall on 
(
Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND Inseeall.lieudeces=ecgen.lieudeces
)
set ercode=103 
where inseeall.id<>ecgen.id;

/*
##################################################################################
#  Ec102 - Double (sexe, datenaiss, lieunaiss, datedeces, lieudeces, actedeces)  #
##################################################################################
*/

/* Peuplement de Ecgen */
truncate table ecgen;

insert into ecgen
select NULL as idec, "", sexe, datenaiss, lieunaiss, datedeces, lieudeces,0,actedeces from Inseeall
group BY
sexe, datenaiss, lieunaiss, datedeces, lieudeces,actedeces
HAVING  
COUNT(*)>1;

/*Ajoute du champ Id dans Ecgen*/
update ecgen inner join Inseeall on
(
Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND Inseeall.lieudeces=ecgen.lieudeces
AND Inseeall.actedeces=ecgen.actedeces
)
set ecgen.id=Inseeall.id;

/*Positionnement du champ ErCode dans Inseeall pour toutes les fiches dont l'Id n'est pas celle de Ecgen*/
update ecgen inner join Inseeall on 
(
Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND Inseeall.lieudeces=ecgen.lieudeces
AND Inseeall.actedeces=ecgen.actedeces
)
set ercode=102 
where inseeall.id<>ecgen.id;

/*
######################################################################################
# Ec101 - Double (nomprenom, sexe, datenaiss, lieunaiss[2], datedeces, lieudeces[2]) #
######################################################################################
*/

/* Peuplement de Ecgen */
truncate table ecgen;

insert into ecgen
select NULL as idec, nomprenom, sexe, datenaiss, substring(lieunaiss,1,2), datedeces, substring(lieudeces,1,2),0,NULL from Inseeall
group BY
nomprenom, sexe, datenaiss, substring(lieunaiss,1,2), datedeces, substring(lieudeces,1,2)
HAVING  
COUNT(*)>1;

/*Ajoute du champ Id dans Ecgen*/
update ecgen inner join Inseeall on
(
Inseeall.nomprenom=ecgen.nomprenom AND Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND substring(Inseeall.lieunaiss,1,2)=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND substring(Inseeall.lieudeces,1,2)=ecgen.lieudeces
)
set ecgen.id=Inseeall.id;

/*Positionnement du champ ErCode dans Inseeall pour toutes les fiches dont l'Id n'est pas celle de Ecgen*/
update ecgen inner join Inseeall on 
(
Inseeall.nomprenom=ecgen.nomprenom AND Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND substring(Inseeall.lieunaiss,1,2)=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND substring(Inseeall.lieudeces,1,2)=ecgen.lieudeces
)
set Ercode=101
Where Inseeall.id<>Ecgen.id;

/*
################################################################################
#  Ec100 - Double (nomprenom, sexe, danaiss, lieunaiss, datedeces, lieudeces)  #
################################################################################
*/

/* Peuplement de Ecgen */
truncate table ecgen;

insert into ecgen
select NULL as idec, nomprenom, sexe, datenaiss, lieunaiss, datedeces, lieudeces,0,NULL from Inseeall
group BY
nomprenom, sexe, datenaiss, lieunaiss, datedeces, lieudeces
HAVING  
COUNT(*)>1;

/*Ajoute du champ Id dans Ecgen*/
update ecgen inner join Inseeall on
(
Inseeall.nomprenom=ecgen.nomprenom AND Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND Inseeall.lieudeces=ecgen.lieudeces
)
set ecgen.id=Inseeall.id;

/*Positionnement du champ ErCode dans Inseeall pour toutes les fiches dont l'Id n'est pas celle de Ecgen*/
update ecgen inner join Inseeall on 
(
Inseeall.nomprenom=ecgen.nomprenom AND Inseeall.sexe=ecgen.sexe AND Inseeall.datenaiss=ecgen.datenaiss
AND Inseeall.lieunaiss=ecgen.lieunaiss AND Inseeall.datedeces=ecgen.datedeces AND Inseeall.lieudeces=ecgen.lieudeces
)
set Ercode=100
Where Inseeall.id<>Ecgen.id;


/* 
On annule les doublons si la date de naissance est inconnue c'est trop dangereux en raison de la contrainte réduite,
et vérification faite au moins trois fiches sont concernées.
*/
Update Inseeall set ErCode=3 where datenaiss="00000000";

/*Effacement EcGen*/ 
DROP TABLE ecgen;



