#######################################################################################
#                                         InseeShort                                  #
#######################################################################################

DROP TABLE IF EXISTS InseeShort;

CREATE TABLE `inseeshort` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sexe` varchar(1) DEFAULT NULL,
  `datenaiss` varchar(8) DEFAULT NULL,
  `datedeces` varchar(8) DEFAULT NULL,
  `lieudeces` varchar(5) DEFAULT NULL,
  `src` varchar(4) DEFAULT NULL,
  `ercode` int(4) DEFAULT '0',
  `age` int(3) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

/* Remplissage */

insert ignore into inseeshort
Select id, sexe, datenaiss, datedeces, lieudeces, src, ercode,

CASE
  WHEN Substring(Datenaiss,5,2)="00" OR Substring(Datenaiss,7,2)="00" 
    THEN 

		Floor((substring(Datedeces,1,4)*365.25+Substring(Datedeces,5,2)*30.5+Substring(Datedeces,7,2)-
		substring(Datenaiss,1,4)*365.25+Substring(Datenaiss,5,2)*30.5+Substring(Datenaiss,7,2))/365.25)

	ELSE

		TIMESTAMPDIFF(YEAR, 
		STR_TO_DATE(DateNaiss, "%Y%m%d"),
		STR_TO_DATE(DateDeces, "%Y%m%d"))
		

END

FROM Inseeall

Where ErCode not in (1,2,3,6,7,8,9,100,101,102,103,104) and substring(lieudeces,1,2) not in ("00","96","97","98","99")
And SubString(DateDeces,1,4)>="2000";

/* Le SQL précédent ne peut "ramasser" des folies du genre 19130229, on va devoir repasser sur les NULL */

Update Inseeshort set Age=

Floor((substring(Datedeces,1,4)*365.25+Substring(Datedeces,5,2)*30.5+Substring(Datedeces,7,2)-
		substring(Datenaiss,1,4)*365.25+Substring(Datenaiss,5,2)*30+Substring(Datenaiss,7,2))/365.25)

Where Age Is Null;

/* on va peut-être effacer les fiches au delà de 117 ans, et en particulier celle qui a 365 ans... */
delete from inseeshort where age>117;

/* Création des Index */

ALTER TABLE `mortalite`.`inseeshort` 
ADD INDEX `Datenaiss` (`datenaiss` ASC),
ADD INDEX `Datedeces` (`datedeces` ASC),
ADD INDEX `LieuDeces` (`lieudeces` ASC),
ADD INDEX `Src` (`src` ASC),
ADD INDEX `Age` (`age` ASC);

Select "**** FINI ****";

#######################################################################################
#                                         InseeResume                                 #
#######################################################################################

DROP TABLE IF EXISTS `inseeresume`;

CREATE TABLE `inseeresume` (
  `dt` datetime DEFAULT NULL,
  `dow` int(11) DEFAULT NULL,
  `biss` int(11) DEFAULT '0',
  `age` int(11) DEFAULT NULL,
  `sexe` int(11) DEFAULT NULL,
  `dep` varchar(2) DEFAULT NULL,
  `deces` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

Insert into inseeresume
select STR_TO_DATE(DateDeces, "%Y%m%d"), DAYOFWEEK(STR_TO_DATE(DateDeces, "%Y%m%d")),
CASE 
	WHEN SubString(DateDeces,5,4)="0229" THEN 1
	ELSE 0
END
,age, sexe, SubString(LieuDeces,1,2), Count(Sexe) from InseeShort
where DateDeces>="2000"
group by STR_TO_DATE(DateDeces, "%Y%m%d"), SubString(LieuDeces,1,2), sexe
order by STR_TO_DATE(DateDeces, "%Y%m%d");

ALTER TABLE `mortalite`.`inseeresume` 
ADD INDEX `Composite` (`dt` ASC, `age` ASC, `sexe` ASC, `dep` ASC);

#######################################################################################
#                                         InseeFine                                   #
#######################################################################################

Call CreateListeFine;

Select "OK, toutes les tâches sont terminées";